/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.gruppe;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.gruppe.boundary.AbstractGruppeSearchParameters;
import de.ivu.elect.business.gruppe.boundary.GruppeChangeEvent;
import de.ivu.elect.business.gruppe.boundary.GruppeConversationStore;
import de.ivu.elect.business.gruppe.boundary.GruppeExtendedDAO;
import de.ivu.elect.business.gruppe.boundary.GruppeSearch;
import de.ivu.elect.business.gruppe.boundary.GruppeSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.gruppe.entity.Gruppe;
import de.ivu.elect.business.gruppe.entity.GruppeMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractGruppeSearchView.COMPONENT_NAME)
@View(viewId = AbstractGruppeSearchView.VIEW_ID, useCase = UseCasePermission.GRUPPE_SEARCH)
public abstract class AbstractGruppeSearchView extends AbstractElectSearchView<Gruppe> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "gruppeSearchView";
  
  public static final String VIEW_ID = "/gruppe/gruppe-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractGruppeSearchView requestHandler;

  @Inject
  private transient GruppeExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(GruppeConversationStore.class)
  protected transient GruppeConversationStore conversationStore;

  @Inject
  protected transient GruppeSearch search;

  @Inject
  @ConversationGroup(AbstractGruppeSearchParameters.class)
  protected transient GruppeSearchParameters searchParameters;

  @Inject
  protected transient GruppeMeta entityMeta;

  public AbstractGruppeSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public Gruppe getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(Gruppe entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public GruppeSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<Gruppe> getEagerLoadingCollector() {
    return EagerLoadingCollector.<Gruppe> create();
  }

  @Override
  public List<Gruppe> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<Gruppe> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onGruppeChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) GruppeChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //   Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractGruppeSearchView {

    @View
    @Inject
    private transient Instance<AbstractGruppeSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractGruppeSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
